<?php
  // XML::MODUL   (Class CRcon)
  // XML::VERSION (0.020)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (Dies ist die PHP-Variante des Perl-Moduls CKkcon)

  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.020";
  $NAME    = "CRcon";
  $AUTHOR  = "DarthPaul, TheTinySteini, ::[CTH]Goldenhawk::";

  // XML::COMMENT (Variablen laden)
  include_once("CConfig.php");

  class CRcon
  {
    // XML::FUNC::sconnect ($self->sconnect(ip=>$ip,port=>$port))
    // XML::DESC::sconncet (Stellt Verbindung zum Server her)
    // XML::VERSION::sconnect  (1.0)
    // XML::RETURN::sconnect ($socket)
	function sconnect($opts)
	{
      $opts = func_get_args();

	  if (!$opts[0][ip])
	  {
	    $opts[0][ip] = "127.0.0.1";
		print $opts[0][ip];
	  }

	  $this->var_server = $opts[0][type];
	  $this->var_rcon_pw = $opts[0][pw];

	  set_time_limit(5);
	  
	  if (!$opts[0][port])
	  {
	    if ($this->var_server == 'q3')
	      $opts[0][port] = "27960";
	    elseif ($this->var_server == 'hl')
	      $opts[0][port] = "27015";
	    else
		  die("Keinen Port angegeben.");
	  }

  	  $socket = fsockopen("udp://".$opts[0][ip]."", $opts[0][port], &$errno, &$errstr);

	  if (!$socket)
	  {
		return false;
	  }
	  else
	  {
        return $socket;
      }
	}

    // XML::FUNC::privReadLong ($self->privReadLong($socket))
    // XML::DESC::privReadLong (Liest Daten vom Server)
    // XML::VERSION::privReadLong  (1.0)
    // XML::RETURN::privReadLong (BOOL|$string)
    function privReadLong($socket)
    {
      $packed = fread($socket, 4);
      $status = socket_get_status($socket);
      if(!$status[timed_out] && !$status[eof])
      {
        $unpacked = unpack("iint", $packed);
        return $unpacked[int];
      }
      else
        return 0;
  	}

    // XML::FUNC::privReadFloat ($self->privReadFloat($socket))
    // XML::DESC::privReadFloat (Liest Daten vom Server)
    // XML::VERSION::privReadFloat  (1.0)
    // XML::RETURN::privReadFloat ($string)
    function privReadFloat($socket)
    {
      $unpacked=unpack("fint",fread($socket,4));
      return $unpacked[int];
    }

    // XML::FUNC::privReadShort ($self->privReadShort($socket))
    // XML::DESC::privReadShort (Liest Daten vom Server)
    // XML::VERSION::privReadShort  (1.0)
    // XML::RETURN::privReadShort ($string)
    function privReadShort($socket)
    {
  	  $unpacked=unpack("sint",fread($socket,2));
	  return $unpacked[int];
	}

    // XML::FUNC::privReadByte ($self->privReadByte($socket))
    // XML::DESC::privReadByte (Liest Daten vom Server)
    // XML::VERSION::privReadByte  (1.0)
    // XML::RETURN::privReadByte ($string)
    function privReadByte($socket)
    {
      return ord(fread($socket,1));
    }

    // XML::FUNC::privReadChar ($self->privReadChar($socket))
    // XML::DESC::privReadChar (Liest Daten vom Server)
    // XML::VERSION::privReadChar  (1.0)
    // XML::RETURN::privReadChar ($string)
    function privReadChar($socket)
    {
      return fread($socket,1);
    }

    // XML::FUNC::privReadString ($self->privReadString($socket))
    // XML::DESC::privReadString (Liest Daten vom Server)
    // XML::VERSION::privReadString  (1.0)
    // XML::RETURN::privReadString ($string)
    function privReadString($socket)
    {
      while( ($bytebuff=$this->privReadChar($socket))!=chr(0) )
      $szString.=$bytebuff;
  	  return $szString;
	}


    // XML::FUNC::getAdvInfo ($self->getAdvInfo($socket))
    // XML::DESC::getAdvInfo (Liest erweiterte Informationen vom Server)
    // XML::VERSION::getAdvInfo  (1.0)
    // XML::RETURN::getAdvInfo ($info)
	function getAdvInfo($socket)
	{
      $a_advinfo = array();

	  if ($this->var_server == 'hl')
      {
        fwrite($socket, sprintf("%c%c%c%c%s%c", 0xFF, 0xFF, 0xFF, 0xFF, "details", 0xFF));
   	    if( $this->privReadLong($socket)!=-1 )
          return false;

   	    // "ASCII 'm' (S2A_INFO_DETAILED)"
   	    if( $this->privReadChar($socket)!="m" )
          return false;

        // this is the same as getinfo()
   	    $a_advinfo[szServerAddress]=$this->privReadString($socket);
   	    $a_advinfo[szHostName]=$this->privReadString($socket);
   	    $a_advinfo[szMapName]=$this->privReadString($socket);
   	    $a_advinfo[szGameDir]=$this->privReadString($socket);
   	    $a_advinfo[szGameType]=$this->privReadString($socket);

  	 	$a_advinfo[iClientCount]=$this->privReadByte($socket);
      	$a_advinfo[iMaxClients]=$this->privReadByte($socket);
      	$a_advinfo[iProtocolVersion]=$this->privReadByte($socket);

        // now the new stuff
        $a_advinfo[iServerType]=$this->privReadByte($socket);
        $a_advinfo[iServerOS]=$this->privReadByte($socket);
        $a_advinfo[iPwdprotect]=$this->privReadByte($socket);

      	if($a_advinfo[iIsMod]=$this->privReadByte($socket))
        {
          // additional infos if running mod
          $a_advinfo[szModURL]=$this->privReadString($socket);
          $a_advinfo[szURLDownload]=$this->privReadString($socket);
          $a_advinfo[iModVersion]=$this->privReadLong($socket);
          $a_advinfo[iDownloadSize]=$this->privReadLong($socket);
          $a_advinfo[iServerSide]=$this->privReadByte($socket);
          $a_advinfo[iClient]=$this->privReadByte($socket);
          $dummy=$this->privReadByte($socket); // one byte too much, don't know what it's for :-(
        }

	    $ar = split(":",$a_advinfo[szServerAddress]);

  	    $a_advinfo[szServerIP] = $ar[0];
  	    $a_advinfo[szServerPort] = $ar[1];
	  }
	  elseif ($this->var_server == 'q3')
	  {
		$a_advinfo = array();

		fwrite($socket, sprintf("%c%c%c%c%s",0xFF,0xFF,0xFF,0xFF,"rcon ".$this->var_rcon_pw." serverinfo"));
		$cnt = 1;
		while($socket)
		{
		  $me = fgets($socket,48);

		  $me = chop($me);
		  $me = trim($me);

		  // XML::COMMENT (Key zuweisen)
		  if (preg_match("/(\S*)(.*)print$/",$me,$ret))
		  {
		    // XML::COMMENT (Neuen Key festlegen)
		    $a_advinfo[$ret[1]] = "not reached";

		  	// XML::COMMENT (Letzten Key berschreiben, damit Wert zugewiesen werden kann)
		  	$this->var_last_key = $ret[1];
		  }

		  // XML::COMMENT (Value zuweisen)
		  elseif (preg_match("/^(.*)$/",$me,$ret))
		  {
			$a_advinfo[$this->var_last_key] = $ret[1];

			// XML::COMMENT (Falls der letzte Key g_maxGameClients war, Schliefe und Connection beenden)
		  	if ($this->var_last_key == 'g_maxGameClients')
		  	{
		  	  break;
		  	}
		  }
		}

   	    $a_advinfo[szServerAddress] = "N/A";
   	    $a_advinfo[szHostName] = $a_advinfo[sv_hostname];
   	    $a_advinfo[szMapName] = $a_advinfo[mapname];
   	    $a_advinfo[szGameDir] = "N/A";
   	    $a_advinfo[szGameType] = $a_advinfo[g_gametype];
  	 	$a_advinfo[iClientCount] = "N/A";
      	$a_advinfo[iMaxClients] = $a_advinfo[sv_maxclients];
      	$a_advinfo[iProtocolVersion] = $a_advinfo[protocol];

        $a_advinfo[iServerType] = "N/A";
        $a_advinfo[iServerOS] = "N/A";
        $a_advinfo[iPwdprotect] = "N/A";
	  }
	  else
	  {
	    return false;
	  }
      return $a_advinfo;
	}

    // XML::FUNC::getPlayers ($self->getPlayers($socket))
    // XML::DESC::getPlayers (Liefert die aktuellen Spieler zurck)
    // XML::VERSION::getPlayers  (1.0)
    // XML::RETURN::getPlayers ($players)
	function getPlayers($socket)
	{
  	  $a_PlayerInfo = array();

	  if ($this->var_server == 'hl')
      {
  	    // header: int32 -1
  	    fwrite($socket, sprintf("%c%c%c%c%s%c", 0xFF, 0xFF, 0xFF, 0xFF, "players", 0x00));

  	  	if( $this->privReadLong($socket)!=-1 )
          return false;

  	    // "ASCII 'D' (players response, S2A_PLAYER)"
  	    if( $this->privReadChar($socket)!="D" )
    	  return false;

 	    // users
	    $iUserCount=$this->privReadByte($socket);
 	    if( $iUserCount>0 )
 	    {
          for( $i=0;$i<$iUserCount;$i++)
          {
		    $a_PlayerInfo[$i][Index]=$this->privReadByte($socket);
            $a_PlayerInfo[$i][Name]=$this->privReadString($socket);
            $a_PlayerInfo[$i][Frags]=$this->privReadLong($socket);
            $flTime=$this->privReadFloat($socket);
      	    $a_PlayerInfo[$i][Time]=sprintf("%02d:%02d",(intval($flTime/60)),($flTime % 60));
    	  }
  	  	}
  	  }
  	  elseif ($this->var_server == 'q3')
  	  {
		fwrite($socket, sprintf("%c%c%c%c%s",0xFF,0xFF,0xFF,0xFF,"rcon ".$this->var_rcon_pw." status"));
		while($socket)
		{
		  $me = fgetc($socket);
		  print $me." - ".ord($me)."\n";
		}
  	  }

  	  return $a_PlayerInfo;
	}


    // XML::FUNC::execCmd ($self->execCmd($socket))
    // XML::DESC::execCmd (Fhrt Kommando aus)
    // XML::VERSION::execCmd  (1.0)
    // XML::RETURN::execCmd ($string)
	function execCmd($socket,$in_rconpw,$command)
	{
	  if ($this->var_server == 'hl')
	  {
	    fwrite($socket, sprintf("%c%c%c%c%s%c", 0xFF, 0xFF, 0xFF, 0xFF, "challenge rcon\n\0", 0x00));
	    $me = fread($socket, 30);
	    $cid = preg_replace("/challenge rcon (.*)/i","\\1",$me);
	    $cid = preg_replace("/(\D+)(\d+)\n/i","\\2",$cid);
	    fwrite($socket, sprintf("%c%c%c%c%s%c", 0xFF, 0xFF, 0xFF, 0xFF, "rcon $cid \"$in_rconpw\" $command", 0x00));
	  }
	  else
	  {
	    fwrite($socket, sprintf("%c%c%c%c%s%c", 0xFF, 0xFF, 0xFF, 0xFF, "rcon \"$in_rconpw\" $command", 0x00));
	  }
      $ans = fread($socket,8);
	  (preg_match("/(.*)Ba/i",$ans,$ar)) ? ($ret = 0) : ($ret = 1);
	  if ($ret == 0)
	    return false;
	  else
	    return true;
	}
  }
?>
