<?php
  // XML::MODUL   (Universal XML-Macros)
  // XML::VERSION (0.1)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (CXml erzeugt aus XML-Macros die jeweilige Ausgabe und erstellt aus Strings XML-Tags)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.1";
  $NAME    = "CXml";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  class CXml
  {
    // XML::FUNC::proofString ($self->proofString($string)
    // XML::DESC::proofString (berprft, ob das angegebene Macro zulssig ist und versucht die passende Funktion aufzurufen)
    // XML::VERSION::proofString  (1.1)
    // XML::RETURN::proofString (BOOl|$string)
    function proofString($my_string)
    {
      // XML::COMMENT (Solange nicht der String geparst wurde, ist return=false)
	  $return = -1;

	  // XML::COMMENT (String auf Gltigkeit prfen)
      if (preg_match("/^XML::(.*) \((.*)\)/i",$my_string,$array))
	  {
		// XML::COMMENT (Globale Variablen zuweisen)
		$this->var_line = $array[0];
		$this->var_macro = $array[1];
		$this->var_string = $array[2];
		$var_macro = $array[1];

		// XML::COMMENT (berprfen, ob Methode existiert)
	    if (!method_exists($this,$this->var_macro))
	    {
	      // XML::COMMENT (Allgemeinen Fehlercode festlegen)
	      $this->errcode = "Unknown macro: \"".$this->var_macro."\"";
	    }
	    else
	    {
	      // XML::COMMENT (Macro ausfhren
	      (call_user_method($this->var_macro,$this)) ? ($return = 1) : ($this->errcode = "The Macro \"".$this->var_macro."\" did not return TRUE.");
		}
      }
	  // XML::COMMENT (XML-Macrosyntax ist falsch)
      else
      {
        $this->errcode = "The string \"$my_string\" has a corrupt XML-Macrosyntax";
      }

	  // XML::COMMENT (Entweder komplette Line oder Egebnis zurckgeben)
	  if ($return == -1)
	    return $this->var_line;
	  else
	    return $this->var_string;
    }

    // XML::FUNC::createXMLEntry ($self->createXMLEntry($opts)
    // XML::DESC::createXMLEntry (Erstellt das erste zweite Objekt einer XML-Struktur)
    // XML::VERSION::createXMLEntry  (1.0)
    // XML::RETURN::createXMLEntry ($string)
	function createXMLEntry($opts,$attrs)
	{
	  // XML::COMMENT (Tag festlegen)
	  $this->xml_tag = $opts[tag];

	  // XML::COMMENT (Dem Tag die Attribute zuweisen
	  if ($attrs)
	  {
	    while (list($key,$val) = each($attrs))
	    {
	      $this->xml_attrs .= " $key=\"".$val."\"";
	    }
	  }

	  if ($opts[last])
	  {
	    $this->xml_fullentry = "  </".$this->xml_tag.">\n\n";
	  }
	  else
	  {
	    $this->xml_fullentry = "\n  <".$this->xml_tag.$this->xml_attrs.">\n";
	  }
	  return $this->xml_fullentry;
	}

    // XML::FUNC::createXMLTag ($self->createXMLTag($opts)
    // XML::DESC::createXMLTag (Erstellt aus dem $opts-Array einen XML-Tag)
    // XML::VERSION::createXMLTag  (1.0)
    // XML::RETURN::createXMLTag ($string)
	function createXMLTag($opts,$attrs)
	{
	  // XML::COMMENT (Tag festlegen)
	  $this->xml_tag = $opts[tag];

	  // XML::COMMENT (Dem Tag die Attribute zuweisen
	  if ($attrs)
	  {
	    while (list($key,$val) = each($attrs))
	    {
	      $this->xml_attrs .= " $key=\"".$val."\"";
	    }
	  }

	  // XML::COMMENT (Falls dem Tag ein Wert zugewiesen wurde)
	  if ($opts[value] || $opts[value] == '0')
	  {
	    // XML::COMMENT (Falls der Wert vom Typ CDATA ist)
	    if ($opts[cdata])
	    {
	      $opts[value] = "    <![CDATA[\n      ".$opts[value]."\n    ]]>";
	    }
	    else
	    {
	      $opts[value] = "\n      $opts[value]\n";
	    }

	    // XML::COMMENT (Endtag festlegen)
	    $this->xml_endtag = "    </".$this->xml_tag.">";
	  }
	  // XML::COMMENT (Abschlieenden Slash festlegen, falls kein Wert vorhanden ist)
	  else
	  {
	    $this->xml_attrs .= " /";
	  }

	  $this->xml_value = $opts[value];

	  // XML::COMMENT (Tag verknpfen)
	  $this->string_xmlfulltag = "    <".$this->xml_tag.$this->xml_attrs.">".$this->xml_value.$this->xml_endtag."\n";

	  // XML::COMMENT (Variablen undeffen)
	  unset($this->xml_tag,$this->xml_attrs,$this->xml_value,$this->xml_endtag);

	  // XML::COMMENT (Werz schlielich zurckliefern)
	  return $this->string_xmlfulltag;

	}

	// XML::MACRO::XML2HtmlTags ($self->XML2HtmlTags())
	// XML::DESC::XML2HtmlTags (Wandelt den bergebenen String in einen HTML-Tag um - Erlaubt den Verzicht auf CDATA in XML-Dateien)
	// XML::VERSION::XML2HtmlTags (1.0)
	// XML::RETURN::XML2HtmlTags ($string_in_class)
	function XML2HtmlTags()
	{
      $this->var_string = "&lt;".$this->var_string."&gt;";
	  return true;
	}
  }

?>